#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const long long INF = 1000000000000000000LL;
int n, k;
vector<int> a;
vector<vector<int>> gr;
vector<int> perm;
long long ans = -INF;

long long cur;
vector<bool> used;
vector<int> st;

bool dfs(int u, int p, int to) {
    st.push_back(u);
    if (u == to) {
        return true;
    }
    for (int v : gr[u]) {
        if (v == p) continue;
        if (dfs(v, u, to)) {
            return true;
        }
    }
    st.pop_back();
    return false;
}

void doit() {
    cur = 0;
    used.assign(n, false);
    for (int i = 0; i < perm.size(); i += 2) {
        st.clear();
        dfs(perm[i], -1, perm[i + 1]);
        for (int x : st) {
            if (used[x]) {
                return;
            }
            used[x] = true;
            cur += a[x];
        }
    }
    ans = max(ans, cur);
}

void gen() {
    if (perm.size() == 2 * k) {
        doit();
        return;
    }
    for (int i = 0; i < n; i++) {
        perm.push_back(i);
        gen();
        perm.pop_back();
    }
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> k;
    a.resize(n);
    gr.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }

    gen();

    cout << ans << endl;

    return 0;
}
