#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const long long INF = 1000000000000000000LL;
int n, k;
vector<int> a;
vector<vector<int>> gr;
vector<vector<int>> w;
vector<vector<int>> go;

void dfs(int u, int p, int rt) {
    go[u][rt] = p;
    for (int v : gr[u]) {
        if (v != p) {
            w[rt][v] = w[rt][u] + a[v];
            dfs(v, u, rt);
        }
    }
}

vector<pair<int, int>> paths;
vector<bool> used;
long long curw;
long long ans;

void gen() {
    if (paths.size() == k) {
        ans = max(ans, curw);
        return;
    }
    int fr = 0;
    if (!paths.empty()) {
        fr = paths.back().first + 1;
    }
    for (int v1 = fr; v1 < n; v1++) {
        for (int v2 = v1 + 1; v2 < n; v2++) {
            int cv = v2;
            bool ok = true;
            vector<int> pth;
            while (cv != -1) {
                pth.push_back(cv);
                if (used[cv]) {
                    ok = false;
                    break;
                }
                cv = go[cv][v1];
            }

            if (ok) {
                for (int v : pth) {
                    used[v] = true;
                    curw += a[v];
                }
                paths.push_back({v1, v2});

                gen();

                paths.pop_back();
                for (int v : pth) {
                    used[v] = false;
                    curw -= a[v];
                }
            }
        }
    }
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> k;
    gr.resize(n);
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }

    w.resize(n);
    go.resize(n);
    for (int i = 0; i < n; i++) {
        w[i].resize(n);
        go[i].resize(n);
    }

    for (int i = 0; i < n; i++) {
        w[i][i] = a[i];
        dfs(i, -1, i);
    }

    curw = 0;
    ans = -INF;
    used.resize(n);

    gen();

    cout << ans << endl;

    return 0;
}
