#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const long long INF = 1000000000000000000LL;
int n, k;
vector<int> a;
vector<vector<int>> gr;
vector<bool> used;

bool mark(int u, int p, int v) {
    if (u == v) {
        used[u] = true;
        return true;
    }
    for (int u1 : gr[u]) {
        if (u1 != p) {
            if (mark(u1, u, v)) {
                used[u] = true;
                return true;
            }
        }
    }
    return false;
}

long long mx;

void dfs(int u, int p, long long cd) {
    cd += a[u];
    mx = max(mx, cd);
    for (int v : gr[u]) {
        if (v != p && !used[v]) {
            dfs(v, u, cd);
        }
    }
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> k;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    gr.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }

    long long best = -INF;

    for (int u = 0; u < n; u++) {
        for (int v = u; v < n; v++) {
            used.assign(n, false);
            mark(u, -1, v);

            long long cur = 0;
            for (int i = 0; i < n; i++) {
                if (used[i]) {
                    cur += a[i];
                }
            }

            if (k == 2) {
                mx = -INF;
                for (int i = 0; i < n; i++) {
                    if (!used[i]) {
                        dfs(i, -1, 0);
                    }
                }

                best = max(best, mx + cur);
            } else {
                best = max(best, cur);
            }
        }
    }

    cout << best << endl;

    return 0;
}