#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

string s, s1;

const int p = 239;
const int MAXN = 2000001;

long long ph1[MAXN], ph2[MAXN], pp[MAXN];

inline long long hsh1(int L, int R) {
    return ph1[R] - ph1[L] * pp[R - L];
}

inline long long hsh2(int L, int R) {
    return ph2[s.length() - L] - ph2[s.length() - R] * pp[R - L];
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> s;
    auto n = (int) s.length();
    s = s + s;
    s1 = s;
    reverse(s1.begin(), s1.end());

    pp[0] = 1;

    for (int i = 0; i < s.length(); i++) {
        pp[i + 1] = pp[i] * p;
        ph1[i + 1] = ph1[i] * p + s[i];
        ph2[i + 1] = ph2[i] * p + s1[i];
    }

    int mx = 0;
    for (int i = 0; i < s.length(); i++) {
        // even
        int L = 0;
        int R = min((n + 1) / 2 + 1, min(i, (int) s.length() - i) + 1);
        while (R - L > 1) {
            int M = (L + R) / 2;
            if (hsh1(i + 1, i + 1 + M) == hsh2(i - M + 1, i + 1)) {
                L = M;
            } else {
                R = M;
            }
        }
        if (2 * L <= n) {
            mx = max(mx, 2 * L);
        }

        // odd
        L = 0;
        R = min((n + 1) / 2 + 1, min(i + 1, (int) s.length() - i) + 1);
        while (R - L > 1) {
            int M = (L + R) / 2;
            if (hsh1(i, i + M) == hsh2(i - M + 1, i + 1)) {
                L = M;
            } else {
                R = M;
            }
        }
        if (2 * L - 1 <= n) {
            mx = max(mx, 2 * L - 1);
        }
    }

    cout << mx << endl;

    return 0;
}
